unit CalcFlds;

{$R-,S-,I-,O-,F-,A+,U+,K+,W-,V+,B-,X+,T-,P+,L+,Y+,D+}

//  These interposer classes allow CanModify to be overridden so that
//  calculated fields may be edited.  This unit must appear after DB
//  in the uses clause in each unit where thia facility is required.

interface

uses
  Classes, DB;

type
  TStringField = class(DB.TStringField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TNumericField = class(DB.TNumericField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TIntegerField = class(DB.TIntegerField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TSmallIntField = class(DB.TSmallIntField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TWordField = class(DB.TWordField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TAutoIncField = class(DB.TAutoIncField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TFloatField = class(DB.TFloatField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TCurrencyField = class(DB.TCurrencyField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TBooleanField = class(DB.TBooleanField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TDateTimeField = class(DB.TDateTimeField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TDateField = class(DB.TDateField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TTimeField = class(DB.TTimeField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TBinaryField = class(DB.TBinaryField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TBytesField = class(DB.TBytesField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TVarBytesField = class(DB.TVarBytesField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TBCDField = class(DB.TBCDField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TBlobField = class(DB.TBlobField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TMemoField = class(DB.TMemoField)
  protected
    function  GetCanModify : boolean; override;
  end;

  TGraphicField = class(DB.TGraphicField)
  protected
    function  GetCanModify : boolean; override;
  end;

implementation

{****************************************************************
* FIELDS                                                        *
****************************************************************}

function TStringField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TNumericField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TIntegerField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TSmallIntField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TWordField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TAutoIncField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TFloatField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TCurrencyField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TBooleanField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TDateTimeField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TDateField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TTimeField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TBinaryField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TBytesField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TVarBytesField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TBCDField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TBlobField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TMemoField.GetCanModify : boolean; begin Result := not ReadOnly; end;

function TGraphicField.GetCanModify : boolean; begin Result := not ReadOnly; end;

end.
